/************************************/
/*   㷨ʾ   */
/*      ϴѧϢѧԺ        */
/************************************/

#include "util.h"

/* ѡ
aint
n鳤 
show_logǷ־ */
void selection_sort(int* a, int n, int show_log) {
	for (int i = 0; i < n - 1; i++) {
		int min = i;
		if(show_log>0) printf("%dѡ\n", i);
		for (int j = i + 1; j < n; j++) {
			if (a[j] < a[min]) {
				min = j;
			}
		}
		if (show_log > 0) {
			print_int_array(a, n);
			printf("%d, %dԪ\n", i, min);
		}	
		swap(a, min, i); // i, minλõԪ
		if (show_log > 0) {
			print_int_array(a, n);
			printf("\n");
		}
		
	}
}


/* 
aint
n鳤
show_logǷ־ */
void insertion_sort(int* a, int n, int show_log) {
	//int m_sum = 0; //Ԫƶ 
	for (int i = 1; i < n; i++) {
		int x = a[i];
		int loc = i - 1;
		// ҵǰֵxĲλ
		while ((loc >= 0) && (a[loc] > x)) {
			a[loc + 1] = a[loc];
			loc--;
			//m_sum++;
		}
		// ҵλloc+1
		if (show_log > 0) {
			printf("%d˲룬%d뵽λ%d\n", i, x, loc + 1);
			print_int_array(a, n);
		}
		
		a[loc + 1] = x;

		if (show_log > 0) {
			printf("\n");
			print_int_array(a, n);
			printf("\n");
		}		
	}
	//printf("Ԫƶ%d\n", m_sum);
}


/* ۰
aint
n鳤
show_logǷ־ */
void binary_insertion_sort(int* a, int n, int show_log) {
	//int m_sum = 0; //Ԫƶ
	for (int i = 1; i < n; i++) {
		int x = a[i];
		
		// ҵǰֵxĲλloc
		int loc = binary_search(a, i - 1, x);
		
		if (show_log > 0) {
			printf("%d˲룬%d뵽λ%d\n", i, x, loc + 1);
			print_int_array(a, n);
		}
		
		for (int k = i - 1; k >= loc; k--) {
			a[k + 1] = a[k];
			//m_sum++;
		}

		a[loc] = x;

		if (show_log > 0) {
			printf("\n");
			print_int_array(a, n);
			printf("\n");
		}
		
	}
	//printf("Ԫƶ%d\n", m_sum);
}

/* ϲб
aϲб
s1, e1һбʼλ
s2, e2ڶбʼλ
*/
void merge_lists(int* a, int s1, int e1, int s2, int e2, int *tmp) {
	int a_start = s1, tmp_index = 0;	
	// бԪؽСĲ
	while ((s1 <= e1) && (s2 <= e2)) {
		if (a[s1] < a[s2]) {
			tmp[tmp_index++] = a[s1++];
		}
		else {
			tmp[tmp_index++] = a[s2++];
		}
	}
	// ӻʣԪصби
	if (s1 <= e1) {
		for (; s1 <= e1; s1++) {
			tmp[tmp_index++] = a[s1];
		}
	}
	else {
		for (; s2 <= e2; s2++) {
			tmp[tmp_index++] = a[s2];
		}
	}
	// ϲƵa
	tmp_index = 0;
	for (int i = a_start; i <= e2; i++) {
		a[i] = tmp[tmp_index++];
	}
}

/* ϲ
aб
l, rбʼλ
tmpݴϲ
show_logǷ־ */
void merge_sort(int* a, int l, int r, int* tmp, int show_log) {
	if (l < r) {
		int m = (l + r) / 2;
		merge_sort(a, l, m, tmp, show_log);
		merge_sort(a, m + 1, r, tmp, show_log);
		
		if (show_log > 0) {
			printf("ϲб%d - %d\n", l, r);
			print_int_array_lr(a, l, r);
		}

		merge_lists(a, l, m, m + 1, r, tmp); // ϲб
		
		if (show_log > 0) {
			printf("ϲб\n");
			print_int_array_lr(a, l, r);
		}
	}
}

// src[beg, mid][mid+1, end]鲢dst飬ǽУȶ
void arrayMerge(int* src, int* dst, int beg, int mid, int end) {
	int i = beg, j = mid + 1, p = beg;
	while (i <= mid && j <= end)
		dst[p++] = src[j] < src[i] ? src[j++] : src[i++];
	while (i <= mid)
		dst[p++] = src[i++];
	while (j <= end)
		dst[p++] = src[j++];
}

// srcȡݹ鲢dstڣΧ[beg, end]Զ£ٸ
// p175 2.2.2.3 ԪظƵ
void mSort_td_lc(int* dst, int* src, int beg, int end) {
	if (beg >= end)
		return;
	int mid = beg + (end - beg) / 2;
	mSort_td_lc(src, dst, beg, mid);
	mSort_td_lc(src, dst, mid + 1, end);
	arrayMerge(src, dst, beg, mid, end);
}

// Եϵĺϲ
void bottomUpMergeSort(int* a, int l, int r, int* tmp) {
	int n = r - l + 1;
	int currentSize;
	int leftStart;

	// 鳤Ϊ1ʼ
	for (currentSize = 1; currentSize <= n - 1; currentSize = 2 * currentSize) {
		// 
		for (leftStart = 0; leftStart < n - 1; leftStart += 2 * currentSize) {
			int mid = min_int(leftStart + currentSize - 1, n - 1);
			int rightEnd = min_int(leftStart + 2 * currentSize - 1, n - 1);

			// ϲ [leftStart...mid]  [mid+1...rightEnd]
			merge_lists(a, leftStart, mid, mid + 1, rightEnd, tmp); 
		}
	}
}


/* 㷨
aֵint
l, rʼλ 
λ */
int partition(int* a, int l, int r) {
	int i = l + 1;
	int j = r;
	int x = a[l];
	while (1) {
		while ((a[i]<x) && (i<=r)) {
			i++;
		}
		while ((a[j]>x) && (j>=l)) {
			j--;
		}
		if (i >= j) break;
		swap(a, i, j);
		i++;
		j--;
	}
	swap(a, l, j);
	return j;
}

/* 
aint
n鳤
show_logǷ־ */
void quick_sort(int* a, int l, int r, int show_log) {
	if (l < r) {
		int p = partition(a, l, r);
		quick_sort(a, l, p - 1, show_log);
		quick_sort(a, p + 1, r, show_log);
	}
}





int main() {
	// 볤Ϊ 7 
	//int a[7] = { 45, 1, 5, 2, 8, 24, 12 };

	int n = 20000000; //  200000   2000000   1000000000;
	int* a = rand_int_array(n, 1000);
	int* b = copy_int_array(a, n);
	int* c = copy_int_array(a, n);
	int* d = copy_int_array(a, n);
	int* e = copy_int_array(a, n);

	printf("鳤ȣ%d, Ԫռڴ棺%dֽ, ռڴ棺%lldֽ\n", n, (int)sizeof(int), n * (long long)sizeof(int));
	print_int_array(a, n);

	//
	//// ѡ
	//clock_t t1 = clock();
	//selection_sort(a, n, 0);
	//clock_t t2 = clock();
	//double rt1 = diff_time_sec(t1, t2);
	//printf("ѡʱ䣺%.3lf sec\n", rt1);
	//	
	//// 
	//clock_t t3 = clock();
	//insertion_sort(b, n, 0);
	//clock_t t4 = clock();
	//double rt2  = diff_time_sec(t3, t4);
	//printf("ʱ䣺%.3lf sec\n", rt2);

	////۰
	//clock_t t5 = clock();
	//binary_insertion_sort(c, n, 0);
	//clock_t t6 = clock();
	//double rt3 = diff_time_sec(t5, t6);
	//printf("۰ʱ䣺%.3lf sec\n", rt3);
	
	//ϲ
	clock_t t7 = clock();
	int* tmp = (int*)malloc(n * (long long)sizeof(int)); // ݴϲ
	merge_sort(d, 0, n-1, tmp, 0);
	//bottomUpMergeSort(d, 0, n - 1, tmp);
	free(tmp);

	//int* dst = copy_int_array(d, n);
	//mSort_td_lc(dst, d, 0, n-1);
	////clock_t t8 = clock();
	//d = copy_int_array(dst, n);
	//free(dst);

	clock_t t8 = clock();
	double rt4 = diff_time_sec(t7, t8);
	printf("ϲʱ䣺%.3lf sec\n", rt4);

	////
	//clock_t t9 = clock();
	//quick_sort(e, 0, n - 1, 0);
	//clock_t t10 = clock();
	//double rt5 = diff_time_sec(t9, t10);
	//printf("ʱ䣺%.3lf sec\n", rt5);


	printf("");
	print_int_array(d, n);

	system("pause");

	/* ͷռõڴ */
	free(a);		
	free(b);
	free(c);
	free(d);
	free(e);

	return 0;
}

