/************************************/
/*   㷨ݳʾ   */
/*      ϴѧϢѧԺ        */
/************************************/

#include "util.h"

void print_array(int* a, int n) {
	for (int i = 0; i < n-1; i++) {
		printf("%d", a[i]);
		printf(", ");
	}
	printf("%d", a[n - 1]);
}

/* Ӽ
x
tǰ
n
nb֧
show_logǷ־ */
void subset_tree(int *x, int t, int n, int nb, int show_log) {
	if (t >= n) {
		if (show_log > 0) {
			printf("t:%d\t", t);
			print_int_array(x, n); //xбĽ
		}
	}
	else {
		for (int i = 0; i < nb; i++) {
			x[t] = i; 
			subset_tree(x, t + 1, n, nb, show_log);
		}
	}
}

/* 
x
tǰ
n
show_logǷ־ */
void permutation_tree(int* x, int t, int n, int show_log) {
	if (t >= n) {
		if (show_log > 0) {
			printf("\t");
			print_array(x, n); //xбĽ
			printf("\n");
		}
	}
	else {
		for (int i = t; i < n; i++) {
			if (show_log > 0) {
				printf("t:%d i:%d ǰ", t, i);
				print_array(x, n); //xбĽ
				printf("\t");
			}
			swap(x, t, i);
			if (show_log > 0) {
				printf("");
				print_array(x, n); //xбĽ
				printf("\n");
			}
			permutation_tree(x, t+1, n, show_log);
			//swap(x, t, i);
		}
	}
}

/* жϻʺǷϷ
x
tǰ */
int place(int* x, int t) {
	for (int j = 0; j < t; j++) {
		if ((x[t] == x[j]) || (abs(t - j) == abs(x[t] - x[j]))) {
			return 0;
		}
	}
	return 1;
}

/* nʺ
x
tǰ
nʺ
na
show_logǷ־ */
void n_queue(int* x, int t, int n, int *na, int show_log) {
	if (t >= n) {
		(*na)++;		
		if (show_log) {
			printf("%d⣺", *na);
			print_int_array(x, n);
			for (int i = 0; i < n; i++) {
				int q = x[i];
				printf("|");
				for (int j = 0; j < n; j++) {
					if (j == q) { printf("Q|"); }
					else { printf("-|"); }
				}
				printf("\n");
			}
			printf("\n");
		}	
	}
	else {
		for (int i = 0; i < n; i++) {
			x[t] = i;
			if (place(x, t)) n_queue(x, t + 1, n, na, show_log);
		}
	}
}

/* ӡڽӾ
xڽӾ
nڵ */
void print_adjacency_matrix(int *x, int n) {
	for (int i = 0; i < n; i++) {
		int row_index = i * n;
		printf("%4d", x[row_index]);
		for (int j = 1; j < n; j++) {
			int a_ij = x[row_index + j];
			printf(", %4d", a_ij);
		}
		printf("\n");
	}
}

/*
xڽӾ
nڵ
iʼڵ
jֹڵ
ر<i, j>Ȩ */
int get_edge_weight(int *x, int n, int i, int j) {
	int index = i * n + j;
	return x[index];
}

/*
xڽӾ
nڵ
tǰ
ccǰȨغ
bestcǰŽȨغ
show_logǷ־ */
void TSP(int* x, int n, int t, int *cc, int *bestc, int show_log) {
	if (t >= n) {

	}
	else {
		
	}
}

//int main() {
//
//	int n = 15;
//	int *x = (int*)malloc(n * (int)sizeof(int));
//	//memset(x, 0, n * (int)sizeof(int));
//	//printf("ʼx: ");
//	//print_int_array(x, n);
//
//	////Ӽ
//	//subset_tree(x, 0, n, 2, 1);
//
//	////
//	//for (int i = 0; i < n; i++) {
//	//	x[i] = i + 1;
//	//}
//	//permutation_tree(x, 0, n, 1);
//
//	//nʺ	
//	int na = 0;
//	clock_t t1 = clock();
//	n_queue(x, 0, n, &na, 0);
//	clock_t t2 = clock();
//	double rt1 = diff_time_sec(t1, t2);
//	printf("%d⣬ʱ䣺%.3lf sec\n", na, rt1);
//
//	////tsp
//	//int g[9] = {1,2,3,4,5,6,7,8,9};
//	//print_adjacency_matrix(g, 3);
//
//
//	free(x);
//	//free(g);
//	return 0;
//}

