/************************************/
/*   㷨ʾ   */
/*      ϴѧϢѧԺ        */
/************************************/

#include "util.h"

/* nĽ׳
룺n
n!
ʱ临ӶȣO(n)
*/
int get_permutation(int n) {
	int res = 1;
	for (int i = 1; i <= n; i++) {
		res = res * i;
	}
	return res;
}
/* жǷһƶԪ
룺
a: Ԫ
d: ͷ
n: 鳤

0ڿƶԪأ
1ڿƶԪ
ʱ临ӶȣO(n)
*/
int mobile(int* a, int* d, int n) {
	if ((d[0]==1) && (a[0]>a[1]) ){
		return 1;
	}
	for (int i = 1; i < n-1; i++) {
		if (a[i]>a[i+d[i]]) {
			return 1;
		}
	}
	if ((d[n-1]==-1) && (a[n-1]>a[n-2])) {
		return 1;
	}
	return 0;
}

/* aҳƶԪ
룺
a: Ԫ
d: ͷ
n: 鳤

index: ƶԪص
ʱ临ӶȣO(n)
*/
int max_k_index(int* a, int* d, int n) {
	int max = -1;
	int index = -1;
	if ((d[0] == 1) && (a[0] > a[1])) {  // ͷ->
		max = a[0];
		index = 0;
	}
	for (int i = 1; i < n - 1; i++) {
		if ((a[i] > max)&&(a[i] > a[i+d[i]])) {
			max = a[i];
			index = i;	
		}	
	}
	if ((d[n - 1] == -1) && (a[n - 1] > a[n - 2]) && (a[n-1]>max)) {  // ͷ<-
		max = a[n - 1];
		index = n - 1;
	}
	return index;
}

/* aԪعɵ
룺
a: Ԫ
n: Ԫĳ

ӡaԪعɵ
ʱ临ӶȣO(n*n!)
*/
void johnson_trotter(int* a, int n) {
	int* d = (int*)malloc(n * sizeof(int));
	for (int i = 0; i < n; i++) {
		d[i] = -1; // 1:ͷ->-1:ͷ<-
	}
	int c = 1;
	printf("%4dУ", c);
	print_int_array(a, n);

	while (mobile(a, d, n) > 0) {  // һƶԪ
		int i = max_k_index(a, d, n); // ĿƶԪ
		int j = i + d[i];
		int k = a[i];

		swap(a, i, j); // ĿƶԪͷָԪؽ
		swap(d, i, j); // ͬʱͷ

		for (int i = 0; i < n; i++) { //ת > k Ԫصķ
			if (a[i] > k) {
				d[i] = 0 - d[i];
			}
		}
		printf("%4dУ", ++c);
		print_int_array(a, n);
	}
	
	free(d);
}

/* ǷԪ
룺
a: Ԫ
n: 鳤

0Ԫ
1Ԫ
ʱ临ӶȣO(n)
*/
int increase(int* a, int n) {
	for (int i = 0; i < n - 1; i++) {
		if (a[i] < a[i + 1]) {
			return 1;
		}
	}
	return 0;
}

/* 
룺ҳԼa_i < a_{i+1} > ... > a_ni
a: Ԫ
n: 鳤
Լi
ʱ临ӶȣO(n)
*/
int max_i_index(int* a, int n) {
	int i = n - 1;
	while (a[i - 1] > a[i]) {
		i--;
	}
	return i - 1;
}

/* ҳԼa_i < a_jj
룺
a: Ԫ
n: 鳤
i: a_i
Լj
ʱ临ӶȣO(n)
*/
int max_j_index(int* a, int n, int i) {
	int j = i + 1;
	while (a[i] < a[j]) {
		j++;
	}
	return j - 1;
}

/* aдijԪ
룺
aԪ
i: ʼ 
j: 
aеԪؽз
ʱ临ӶȣO(|j-i|)
*/
void reverse(int* a, int i, int j) {
	while (i < j) {
		swap(a, i, j);
		i++;
		j--;
	}
}

/* ĸaԪعɵ
룺
a: Ԫ
n: 鳤

ӡĸaԪعɵ
ʱ临ӶȣO(n*n!)
*/
void lexicographic_permute(int* a, int n) {
	int c = 1;
	printf("%4dУ", c);
	print_int_array(a, n);

	while (increase(a, n) > 0) {
		int i = max_i_index(a, n);
		int j = max_j_index(a, n, i);
		swap(a, i, j);
		reverse(a, i + 1, n - 1);

		printf("%4dУ", ++c);
		print_int_array(a, n);
	}
}


//int main() {
//
//	int n = 4; 
//	int* a = (int*)malloc(n * sizeof(int));
//	for (int i = 0; i < n; i++) {
//		a[i] = i+1;
//	}
//	print_int_array(a, n);
//
//	int r = get_permutation(n);
//	printf("n! = %ld\n", r);
//
//	//johnson_trotter(a, n);
//
//	lexicographic_permute(a, n);
//
//	free(a);
//	return 0;
//}